#ifndef _LVE_API_H_

#define _LVE_API_H_

#ifndef __user
#define __user
#endif

#define open_cookie_size 10

struct open_cookie {
	char	data[open_cookie_size];
};

enum {
	LIM_CPU = 0,
	LIM_IO,
	LIM_ENTER,
	LVE_LIMITS_MAX
};

typedef int32_t lve_limits_t[LVE_LIMITS_MAX];

/**
 last two digits is API version
 */
typedef enum {
	DEFAULT_PARAMS,
	ENTER_VE,
	LEAVE_VE,
	CREATE_VE,
	DESTROY_VE,
	SETUP_VE,
	FLUSH_VE,
	API_VER, /* return api version to the caller */
	INFO_VE, /* return info about LVE context */
	/* new in 0.7 */
	DEFAULT_PARAMS_05,
	SETUP_VE_05,
	SETUP_ENTER_VE_05,
	INFO_VE_05
} ve_op;

struct ve_enter {
	int32_t		uid;	/* user id, -1 if switch not need */
	int32_t		gid;	/* group id, -1 if switch not need */
	uint32_t __user	*cookie; /* pointer to enter cookie */
	/* for set groups */
	int 		grp_size;
	gid_t __user 	*grp_list;
};

struct ve_leave {
	uint32_t __user	*cookie; /* */
};

struct lve_flush {
	uint32_t	all;	/* flush all context's or only default cloned */
};

struct ve_config_05 {
	lve_limits_t	ulimits;
};

#define ve_config ve_config_05

struct lve_setup_enter_05 {
	struct ve_config __user	*setup;
	struct ve_enter	__user	*enter;
};

struct ve_ioctl {
	uint32_t	id;
	uint32_t	cookie[4];
	void __user	*data;
};

#define LVE_KMOD_API_MAJOR	0
#define LVE_KMOD_API_MINOR	5

#define LVE_API_VERSION(a,b) (((a) << 16) + (b))

#define LVE_DEV_NAME	"lve"

#endif
