#include <stdio.h>
#include <stdint.h>
#include <errno.h>

#include "lve-ctl.h"
#include "kapi/kapi.h"

int lve_is_available(void)
{
	return kapi_init();
}

int lve_instance_init(struct liblve *lve)
{
	int rc;

	rc = kapi_init();
	if (rc < 0)
		return rc;

	KAPI_CALL(lib_init, lve);
}

int lve_instance_destroy(struct liblve *lve)
{
	KAPI_CALL(lib_fini, lve);
}

int lve_enter(struct liblve *lve,
              uint32_t ve_id, int32_t uid,
              int32_t gid, uint32_t *cookie)
{
	KAPI_CALL(lve_enter, lve, ve_id, cookie);
}

int lve_leave(struct liblve *lib, uint32_t *cookie)
{
	KAPI_CALL(lve_leave, lib, cookie);
}

int
lve_set_default(int32_t cpu, int32_t io, int32_t maxentryproc)
{
	KAPI_CALL(lve_default, cpu, io, maxentryproc);
}

int lve_create(uint32_t ve_id)
{
	KAPI_CALL(lve_create, ve_id);
}

int lve_destroy(uint32_t ve_id)
{
	KAPI_CALL(lve_destroy, ve_id);
}

int lve_setup(uint32_t ve_id, int32_t cpu, int32_t io, int32_t maxentryproc)
{
	KAPI_CALL(lve_setup, ve_id, cpu, io, maxentryproc);
}

int lve_setup_enter(uint32_t ve_id, int32_t cpu, int32_t io, int32_t maxentryproc,
		    uint32_t *cookie)
{
	KAPI_CALL(lve_setup_enter, ve_id, cpu, io, maxentryproc, cookie);
}

int lve_flush(int all)
{
	KAPI_CALL(lve_flush, all);
}

int lve_info(uint32_t ve_id, 
		int32_t *cpu, int32_t *io, int32_t *maxenters)
{
	KAPI_CALL(lve_info, ve_id, cpu, io, maxenters);
}
